# SPDX-FileCopyrightText: Copyright © DUNE Project contributors, see file AUTHORS.md
# SPDX-License-Identifier: LicenseRef-GPL-2.0-only-with-DUNE-exception OR LGPL-3.0-or-later

find_package(Uncrustify 0.72 EXACT)

macro (dune_add_formatting_targets)
  if(Uncrustify_FOUND)
    set(Uncrustify_CFG uncrustify-0.72.cfg)
    set(Uncrustify_OPTIONS -l CPP -c ${Uncrustify_CFG})
    set(Uncrustify_FIND_FILES find ./dune/assembler ./src -type f -iname \"*.cc\" -o -iname \"*.hh\" | xargs)

    add_custom_target(
      check-format
      COMMAND ${Uncrustify_FIND_FILES} ${Uncrustify_PROGRAM} ${Uncrustify_OPTIONS} --check
      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    )

    add_custom_target(
      fix-format
      COMMAND ${Uncrustify_FIND_FILES} ${Uncrustify_PROGRAM} ${Uncrustify_OPTIONS} --no-backup
      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    )
  endif(Uncrustify_FOUND)
endmacro()
