# SPDX-FileCopyrightText: Copyright © DUNE Project contributors, see file AUTHORS.md
# SPDX-License-Identifier: LicenseRef-GPL-2.0-only-with-DUNE-exception OR LGPL-3.0-or-later

find_program(Uncrustify_PROGRAM uncrustify)

if (Uncrustify_PROGRAM)
  # Runs the command to get the version
  execute_process(COMMAND ${Uncrustify_PROGRAM} --version
    OUTPUT_VARIABLE UNCRUSTIFY_VERSION_OUTPUT)

  # Extracts the version from the output of the command run before
  string(REGEX REPLACE "[Uu]ncrustify[-]?" "" UNCRUSTIFY_VERSION_OUTPUT "${UNCRUSTIFY_VERSION_OUTPUT}")
  string(STRIP ${UNCRUSTIFY_VERSION_OUTPUT} Uncrustify_VERSION)
  unset(UNCRUSTIFY_VERSION_OUTPUT)
endif()

# Report if package was found
include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(Uncrustify
  REQUIRED_VARS
    Uncrustify_PROGRAM
  VERSION_VAR
    Uncrustify_VERSION
)

unset(UNCRUSTIFY_HANDLE_VERSION_RANGE)

# text for feature summary
include(FeatureSummary)
set_package_properties("Uncrustify" PROPERTIES
  DESCRIPTION "A source code beautifier"
  URL "https://github.com/uncrustify/uncrustify"
  PURPOSE "To unify the code formatting")
