// -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
// vi: set et ts=4 sw=2 sts=2:

// SPDX-FileCopyrightText: Copyright © DUNE Project contributors, see file AUTHORS.md
// SPDX-License-Identifier: LicenseRef-GPL-2.0-only-with-DUNE-exception OR LGPL-3.0-or-later

#ifndef DUNE_ASSEMBLER_UTILITY_HH
#define DUNE_ASSEMBLER_UTILITY_HH

#include <dune/common/rangeutilities.hh>

namespace Dune::Assembler::Impl {

template <class Node>
auto localIndices (const Node& node)
{
  return Dune::range(node.localIndex(0), node.localIndex(0) + node.size());
}

} // end namespace Dune::Assembler::Impl

#endif // DUNE_ASSEMBLER_UTILITY_HH
