<!--
SPDX-FileCopyrightText: Copyright © DUNE Project contributors, see file AUTHORS.md
SPDX-License-Identifier: LicenseRef-GPL-2.0-only-with-DUNE-exception OR LGPL-3.0-or-later
-->

# Assemblers in dune-fufem

This currently contains a few utilities for global assemblers
from dune-fufem:

* `backends` contains a matrix backend for
  `numpy` arrays and `scipy.sparse.csr_matrix` which
  only supports flat indices.
* `parallel` contains some support code for thread parallel
  algorithms. Besides a reduced implementation of `std::barrier`
  this is some helper code for parallel algorithms and
  a graph coloring algorithm
* `QuadratureRuleKey` for computing and identifying quadrature rules.
* `ShapeFunctionCache` a hierarchic cache for shape function evaluations
  for dune-functions local basis trees.

Among the assembler-related stuff in dune-fufem there is some
more which was deriberately left out so far but might be added
later for discussion. Most interesting here would maybe be:

* Boundary and skeleton assemblers.
* `BoundaryPatch` for marking and iterating parts of the domain
  boundary.
* `Dune::Fufem::Forms` for defining local assemblers in a UFL-like
  way (relies on `ShapeFunctionCache` and `BoundaryPatch`).
